/* audio_l.h
 *
 * low level driver for the
 */

#ifndef AUDIO_L_H
#define AUDIO_L_H

#include <xio.h>
#include <xbasic_types.h>


#define LEFT  0  /* left channel */
#define RIGHT 1  /* right channel */

#define AUDIO_CR_ENABLE_MASK      0x1 /* enable the codec */
#define AUDIO_CR_INT_ENABLE_MASK  0x2 /* enable the interrupts */


#define AUDIO_CTRL_OFFSET    0
#define AUDIO_INPUT_OFFSET   4
#define AUDIO_OUTPUT_OFFSET 12

#define XAudio_mSetControlReg(BaseAddress, Value) \
    XIo_Out32((BaseAddress + AUDIO_CTRL_OFFSET), Value)

#define XAudio_mReadControlReg(BaseAddress) \
    XIo_In32((BaseAddress + AUDIO_CTRL_OFFSET))

#define XAudio_mReadInput(BaseAddress, Channel) \
    XIo_In32((BaseAddress + AUDIO_INPUT_OFFSET + (4 * Channel)))

/* the Channel is LEFT or RIGHT.  The Stream is 0 through 3 which correspond
to outputs 1 through 4 on the sound board */
#define XAudio_mWriteOutput(BaseAddress, Channel, Stream, Value) \
    XIo_Out32((BaseAddress + AUDIO_OUTPUT_OFFSET + (4 * Channel) \
               + (8 * Stream)), Value)

#endif
